#include "websockets.h"

websockets::websockets(){
  webSocket = new WebSocketsClient();
  _WiFiMulti = new WiFiMulti();
}

// hexdump function for websockets binary handler
void websockets::hexdump(const void *mem, uint32_t len, uint8_t cols) {
	const uint8_t* src = (const uint8_t*) mem;
	USE_SERIAL.printf("\n[HEXDUMP] Address: 0x%08X len: 0x%X (%d)", (ptrdiff_t)src, len, len);
	for(uint32_t i = 0; i < len; i++) {
		if(i % cols == 0) {
			USE_SERIAL.printf("\n[0x%08X] 0x%08X: ", (ptrdiff_t)src, i);
		}
		USE_SERIAL.printf("%02X ", *src);
		src++;
	}
	USE_SERIAL.printf("\n");
}

// special function to setup websocket
void websockets::websocketSetup(){
	_WiFiMulti->addAP("iotroam", "vbK9gbDBIB");
  _WiFiMulti->addAP("LansanKPN-boven", "19sander71vlieland14");

	while(_WiFiMulti->run() != WL_CONNECTED) {
		delay(100);
	}

	// server address, port and URL
	webSocket->begin("145.92.8.114", 80, "/ws");

	// try ever 500 again if connection has failed
	webSocket->setReconnectInterval(500);
}

void websockets::loop(){
	webSocket->loop();
}

// handler for websocket events
void websockets::webSocketEvent(WStype_t type, uint8_t * payload, size_t length) {
	switch(type) {
		case WStype_DISCONNECTED:
			USE_SERIAL.printf("[WSc] Disconnected!\n");
			break;
		case WStype_CONNECTED:
			USE_SERIAL.printf("[WSc] Connected to url: %s\n", payload);

			// send message to server when Connected
			webSocket->sendTXT("{\"message\": \"Connected\"}");
			break;
		case WStype_TEXT:
			// send message to server
			// webSocket->sendTXT("message here");
			break;
		case WStype_BIN:
			// USE_SERIAL.printf("[WSc] get binary length: %u\n", length);
			hexdump(payload, length);

			// send data to server
			// webSocket->sendBIN(payload, length);
			break;
		case WStype_ERROR:			
		case WStype_FRAGMENT_TEXT_START:
		case WStype_FRAGMENT_BIN_START:
		case WStype_FRAGMENT:
		case WStype_FRAGMENT_FIN:
			break;
	}
}

void websockets::sendMyText(String message) {

    webSocket->sendTXT(message);

}



